package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateSecurityGroupRuleLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewCreateSecurityGroupRuleLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateSecurityGroupRuleLogic {
	return &CreateSecurityGroupRuleLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *CreateSecurityGroupRuleLogic) CreateSecurityGroupRule(req *types.CreateSecurityGroupRuleReq) (resp *types.CreateSecurityGroupRuleResp, err error) {
	// todo: add your logic here and delete this line
	CreateSecurityGroupRuleReq := &openstack.CreateSecurityGroupRuleReq{}
	err = copier.CopyWithOption(CreateSecurityGroupRuleReq, req, copier.Option{Converters: utils.Converters})
	CreateSecurityGroupRuleResp, err := l.svcCtx.OpenstackRpc.CreateSecurityGroupRule(l.ctx, CreateSecurityGroupRuleReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&CreateSecurityGroupRuleResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &CreateSecurityGroupRuleResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
